oyConnectorImaging_s Struct Reference
Description: C source code API documentation for the Oyranos project.
Keywords: Oyranos,Color Management,Color Management,ICC,CMS,C,doxygen,API,documentation

| Oyranos Color Management System API - Version 0.9.6

Public Member Functions | Data Fields
oyConnectorImaging_s Struct Reference
Conversion

Node connection descriptor. More...

`#include <oyConnectorImaging_s.h>`

Inheritance diagram for oyConnectorImaging_s:
Collaboration diagram for oyConnectorImaging_s:

## Public Member Functions
OYAPI oyConnectorImaging_s *OYEXPORT | oyConnectorImaging_New (oyObject_s object)
| allocate a new ConnectorImaging object More...
| oyConnectorImaging_Copy
| Copy or Reference a ConnectorImaging object. More...
OYAPI int OYEXPORT | oyConnectorImaging_Release (oyConnectorImaging_s **connectorimaging)
| release and possibly deallocate a oyConnectorImaging_s object More...
OYAPI int OYEXPORT | oyConnectorImaging_SetDataTypes (oyConnectorImaging_s *c, oyDATATYPE_e *data_types, int data_types_n)
| Set data types capability of oyConnectorImaging_s. More...
OYAPI int OYEXPORT | oyConnectorImaging_GetDataTypes (oyConnectorImaging_s *c, const oyDATATYPE_e **data_types, int *data_types_n)
| Get capabilities of oyConnectorImaging_s. More...
OYAPI int OYEXPORT | oyConnectorImaging_GetChannelTypes (oyConnectorImaging_s *c, const oyCHANNELTYPE_e **channel_types, int *channel_types_n)
| Get capabilities of oyConnectorImaging_s. More...
OYAPI int OYEXPORT | oyConnectorImaging_GetCapability (oyConnectorImaging_s *c, oyCONNECTOR_IMAGING_CAP_e type)
| Get capabilities of oyConnectorImaging_s. More...
OYAPI int OYEXPORT | oyConnectorImaging_SetCapability (oyConnectorImaging_s *c, oyCONNECTOR_IMAGING_CAP_e type, int value)
| Set capabilities of oyConnectorImaging_s. More...
OYAPI int OYEXPORT | oyConnectorImaging_SetTexts (oyConnectorImaging_s *obj, oyCMMGetText_f getText, const char **text_classes)
| set the texts in a connector More...
OYAPI const char **OYEXPORT | oyConnectorImaging_GetTexts (oyConnectorImaging_s *obj)
| get the text classes in a connector More...
OYAPI const char *OYEXPORT | oyConnectorImaging_GetText (oyConnectorImaging_s *obj, const char *name_class, oyNAME_e type)
| get the names in a connector More...
int | oyConnectorImaging_IsPlug (oyConnectorImaging_s *obj)
| Is this connector a plug or a socket. More...
int | oyConnectorImaging_SetIsPlug (oyConnectorImaging_s *obj, int is_plug)
| Set this connector as a plug or a socket. More...
const char * | oyConnectorImaging_GetReg (oyConnectorImaging_s *obj)
| Get the registration for the connection type. More...
int | oyConnectorImaging_SetReg (oyConnectorImaging_s *obj, const char *type_registration)
| Set this connectors type string. More...
int | oyConnectorImaging_SetMatch (oyConnectorImaging_s *obj, oyCMMFilterSocket_MatchPlug_f func)
| Set this connectors type check function. More...
oyCMMFilterSocket_MatchPlug_f | oyConnectorImaging_GetMatch (oyConnectorImaging_s *obj)
| Set this connectors type check function. More...
Public Member Functions inherited from oyConnector_s
OYAPI oyConnector_s *OYEXPORT | oyConnector_New (oyObject_s object)
| allocate a new Connector object More...
| oyConnector_Copy
| Copy or Reference a Connector object. More...
OYAPI int OYEXPORT | oyConnector_Release (oyConnector_s **connector)
| release and possibly deallocate a oyConnector_s object More...
OYAPI int OYEXPORT | oyConnector_SetTexts (oyConnector_s *obj, oyCMMGetText_f getText, const char **text_classes)
| set the texts in a connector More...
OYAPI const char **OYEXPORT | oyConnector_GetTexts (oyConnector_s *obj)
| get the text classes in a connector More...
OYAPI const char *OYEXPORT | oyConnector_GetText (oyConnector_s *obj, const char *name_class, oyNAME_e type)
| get the names in a connector More...
int | oyConnector_IsPlug (oyConnector_s *obj)
| Is this connector a plug or a socket. More...
int | oyConnector_SetIsPlug (oyConnector_s *obj, int is_plug)
| Set this connector as a plug or a socket. More...
const char * | oyConnector_GetReg (oyConnector_s *obj)
| Get the registration for the connection type. More...
int | oyConnector_SetReg (oyConnector_s *obj, const char *type_registration)
| Set this connectors type string. More...
int | oyConnector_SetMatch (oyConnector_s *obj, oyCMMFilterSocket_MatchPlug_f func)
| Set this connectors type check function. More...
oyCMMFilterSocket_MatchPlug_f | oyConnector_GetMatch (oyConnector_s *obj)
| Set this connectors type check function. More...
Public Member Functions inherited from oyStruct_s
const char * | oyStruct_GetTextFromModule (oyStruct_s *obj, oyNAME_e name_type, uint32_t flags)
| get object infos from a module More...
const char * | oyStruct_GetText (oyStruct_s *obj, oyNAME_e name_type, uint32_t flags)
| Get a text dump. More...
| oyStruct_RegisterStaticMessageFunc
| register a function for verbosity More...
| oyStruct_GetInfo
| get a additional string from a object More...
const char * | oyStructTypeToText (oyOBJECT_e type)
| Objects type to small string. More...

## Data Fields
const oyOBJECT_e | type_
| Type of object. More...
oyStruct_Copy_f | copy
| Copy function. More...
oyStruct_Release_f | release
| Release function. More...
oyObject_s | oy_
| Oyranos internal object. More...
Data Fields inherited from oyConnector_s
const oyOBJECT_e | type_
| Type of object. More...
oyStruct_Copy_f | copy
| Copy function. More...
oyStruct_Release_f | release
| Release function. More...
oyObject_s | oy_
| Oyranos internal object. More...
Data Fields inherited from oyStruct_s
const oyOBJECT_e | type_
| Type of object. More...
oyStruct_Copy_f | copy
| Copy function. More...
oyStruct_Release_f | release
| Release function. More...
oyObject_s | oy_
| Oyranos internal object. More...

## Detailed Description

Node connection descriptor.

This structure holds informations about the connection capabilities. It holds common structure members of oyFilterPlug_s and oyFilterSocket_s.

To signal a value is not initialised or does not apply, set the according integer value to -1.

Todo:
  generalise the connector properties

Version
  Oyranos: 0.1.10

Since
  2008/07/26 (Oyranos: 0.1.8)

Date
  2010/06/25

Examples:
  oyranos_cmm_oJPG.c.

## Member Function Documentation

## ◆ oyConnectorImaging_Copy()

oyConnectorImaging_Copy

Copy or Reference a ConnectorImaging object.

The function is for copying and for referencing. The reference is the most often used way, which saves resourcs and time.

Parameters

  [in] | connectorimaging | ConnectorImaging struct object
  | object | NULL - means reference, the optional object triggers a real copy

## ◆ oyConnectorImaging_GetCapability()

OYAPI int OYEXPORT oyConnectorImaging_GetCapability | ( | oyConnectorImaging_s * | c,
|  | oyCONNECTOR_IMAGING_CAP_e | type
| ) |  |

Get capabilities of oyConnectorImaging_s.

Function oyConnectorImaging_GetDataTypes

Version
  Oyranos: 0.5.0

Date
  2012/09/06

Since
  2012/09/06 (Oyranos: 0.5.0)

References oyCONNECTOR_IMAGING_CAP_CAN_INTERWOVEN, oyCONNECTOR_IMAGING_CAP_CAN_NONPREMULTIPLIED_ALPHA, oyCONNECTOR_IMAGING_CAP_CAN_PLANAR, oyCONNECTOR_IMAGING_CAP_CAN_PREMULTIPLIED_ALPHA, oyCONNECTOR_IMAGING_CAP_CAN_REVERT, oyCONNECTOR_IMAGING_CAP_CAN_SUBPIXEL, oyCONNECTOR_IMAGING_CAP_CAN_SWAP, oyCONNECTOR_IMAGING_CAP_CAN_SWAP_BYTES, oyCONNECTOR_IMAGING_CAP_ID, oyCONNECTOR_IMAGING_CAP_IS_PLUG, oyCONNECTOR_IMAGING_CAP_MAX_CHANNELS_COUNT, oyCONNECTOR_IMAGING_CAP_MAX_COLOR_COUNT, oyCONNECTOR_IMAGING_CAP_MAX_COLOR_OFFSET, oyCONNECTOR_IMAGING_CAP_MIN_CHANNELS_COUNT, oyCONNECTOR_IMAGING_CAP_MIN_COLOR_COUNT, and oyOBJECT_CONNECTOR_IMAGING_S.

## ◆ oyConnectorImaging_GetChannelTypes()

OYAPI int OYEXPORT oyConnectorImaging_GetChannelTypes | ( | oyConnectorImaging_s * | c,
|  | const oyCHANNELTYPE_e ** | channel_types,
|  | int * | channel_types_n
| ) |  |

Get capabilities of oyConnectorImaging_s.

Function oyConnectorImaging_GetChannelTypes

Version
  Oyranos: 0.5.0

Date
  2012/09/06

Since
  2012/09/06 (Oyranos: 0.5.0)

References oyOBJECT_CONNECTOR_IMAGING_S.

## ◆ oyConnectorImaging_GetDataTypes()

OYAPI int OYEXPORT oyConnectorImaging_GetDataTypes | ( | oyConnectorImaging_s * | c,
|  | const oyDATATYPE_e ** | data_types,
|  | int * | data_types_n
| ) |  |

Get capabilities of oyConnectorImaging_s.

Function oyConnectorImaging_GetDataTypes

Version
  Oyranos: 0.5.0

Date
  2012/09/06

Since
  2012/09/06 (Oyranos: 0.5.0)

References oyOBJECT_CONNECTOR_IMAGING_S.

## ◆ oyConnectorImaging_GetMatch()

oyCMMFilterSocket_MatchPlug_f oyConnectorImaging_GetMatch | ( | oyConnectorImaging_s * | obj | ) |

Set this connectors type check function.

Function oyConnectorImaging_GetMatch

This is use as a check, if connections are possible. This allowes for a more fine grained control than the type registration.

Parameters

  [in] | obj | ConnectorImaging object

Returns
  the check function

Version
  Oyranos: 0.3.0

Since
  2011/01/31 (Oyranos: 0.3.0)

Date
  2011/01/31

## ◆ oyConnectorImaging_GetReg()

const char * oyConnectorImaging_GetReg | ( | oyConnectorImaging_s * | obj | ) |

Get the registration for the connection type.

Function oyConnectorImaging_GetReg

This is use as a rough check, if connections are possible.

Parameters

  [in] | obj | ConnectorImaging object

Returns
  registration string

Version
  Oyranos: 0.3.0

Since
  2011/01/31 (Oyranos: 0.3.0)

Date
  2011/01/31

## ◆ oyConnectorImaging_GetText()

OYAPI const char *OYEXPORT oyConnectorImaging_GetText | ( | oyConnectorImaging_s * | obj,
|  | const char * | name_class,
|  | oyNAME_e | type
| ) |  |

get the names in a connector

Function oyConnectorImaging_GetText

Get UI strings.

Parameters

  [in] | obj | ConnectorImaging object
  [in] | name_class | the names class, e.g. "name", "help" ...
  [in] | type | the names type

Returns
  the name string

Version
  Oyranos: 0.9.5

Since
  2011/01/31 (Oyranos: 0.3.0)

Date
  2013/06/10

## ◆ oyConnectorImaging_GetTexts()

OYAPI const char **OYEXPORT oyConnectorImaging_GetTexts | ( | oyConnectorImaging_s * | obj | ) |

get the text classes in a connector

Function oyConnectorImaging_GetTexts

Set UI strings.

Parameters

  [in] | obj | ConnectorImaging object

Returns
  text_classes zero terminated list of classes, e.g. {"name",NULL}

Version
  Oyranos: 0.9.5

Date
  2013/06/10

Since
  2013/06/10 (Oyranos: 0.9.5)

## ◆ oyConnectorImaging_IsPlug()

int oyConnectorImaging_IsPlug | ( | oyConnectorImaging_s * | obj | ) |

Is this connector a plug or a socket.

Function oyConnectorImaging_IsPlug

Parameters

  [in] | obj | ConnectorImaging object

Returns
  boolean; 0 - socket; 1 - plug

Version
  Oyranos: 0.3.0

Since
  2011/01/31 (Oyranos: 0.3.0)

Date
  2011/01/31

## ◆ oyConnectorImaging_New()

OYAPI oyConnectorImaging_s *OYEXPORT oyConnectorImaging_New | ( | oyObject_s | object | ) |

allocate a new ConnectorImaging object

Function oyConnectorImaging_New

Examples:
  oyranos_cmm_oJPG.c.

References oyOBJECT_OBJECT_S.

## ◆ oyConnectorImaging_Release()

OYAPI int OYEXPORT oyConnectorImaging_Release | ( | oyConnectorImaging_s ** | connectorimaging | ) |

release and possibly deallocate a oyConnectorImaging_s object

Function oyConnectorImaging_Release

Parameters

  [in,out] | connectorimaging | ConnectorImaging struct object

## ◆ oyConnectorImaging_SetCapability()

OYAPI int OYEXPORT oyConnectorImaging_SetCapability | ( | oyConnectorImaging_s * | c,
|  | oyCONNECTOR_IMAGING_CAP_e | type,
|  | int | value
| ) |  |

Set capabilities of oyConnectorImaging_s.

Function oyConnectorImaging_SetCapability

Version
  Oyranos: 0.9.5

Date
  2013/06/14

Since
  2013/06/14 (Oyranos: 0.9.5)

Examples:
  oyranos_cmm_oJPG.c.

References oyCONNECTOR_IMAGING_CAP_CAN_INTERWOVEN, oyCONNECTOR_IMAGING_CAP_CAN_NONPREMULTIPLIED_ALPHA, oyCONNECTOR_IMAGING_CAP_CAN_PLANAR, oyCONNECTOR_IMAGING_CAP_CAN_PREMULTIPLIED_ALPHA, oyCONNECTOR_IMAGING_CAP_CAN_REVERT, oyCONNECTOR_IMAGING_CAP_CAN_SUBPIXEL, oyCONNECTOR_IMAGING_CAP_CAN_SWAP, oyCONNECTOR_IMAGING_CAP_CAN_SWAP_BYTES, oyCONNECTOR_IMAGING_CAP_ID, oyCONNECTOR_IMAGING_CAP_IS_PLUG, oyCONNECTOR_IMAGING_CAP_MAX_CHANNELS_COUNT, oyCONNECTOR_IMAGING_CAP_MAX_COLOR_COUNT, oyCONNECTOR_IMAGING_CAP_MAX_COLOR_OFFSET, oyCONNECTOR_IMAGING_CAP_MIN_CHANNELS_COUNT, oyCONNECTOR_IMAGING_CAP_MIN_COLOR_COUNT, and oyOBJECT_CONNECTOR_IMAGING_S.

## ◆ oyConnectorImaging_SetDataTypes()

OYAPI int OYEXPORT oyConnectorImaging_SetDataTypes | ( | oyConnectorImaging_s * | c,
|  | oyDATATYPE_e * | data_types,
|  | int | data_types_n
| ) |  |

Set data types capability of oyConnectorImaging_s.

Function oyConnectorImaging_SetDataTypes

Parameters

  c | the image connector
  data_types | array of supported data types, const
  data_types_n | number of elements in data_types

Returns
  error

Version
  Oyranos: 0.9.5

Date
  2013/06/14

Since
  2013/06/14 (Oyranos: 0.9.5)

Examples:
  oyranos_cmm_oJPG.c.

References oyOBJECT_CONNECTOR_IMAGING_S.

## ◆ oyConnectorImaging_SetIsPlug()

int oyConnectorImaging_SetIsPlug | ( | oyConnectorImaging_s * | obj,
|  | int | is_plug
| ) |  |

Set this connector as a plug or a socket.

Function oyConnectorImaging_SetIsPlug

Parameters

  [in,out] | obj | ConnectorImaging object
  [in] | is_plug | boolean; 0 - socket; 1 - plug

Returns
  1 - error; 0 - success; -1 - otherwise

Version
  Oyranos: 0.3.0

Since
  2011/01/31 (Oyranos: 0.3.0)

Date
  2011/01/31

Examples:
  oyranos_cmm_oJPG.c.

## ◆ oyConnectorImaging_SetMatch()

int oyConnectorImaging_SetMatch | ( | oyConnectorImaging_s * | obj,
|  | oyCMMFilterSocket_MatchPlug_f | func
| ) |  |

Set this connectors type check function.

Function oyConnectorImaging_SetMatch

This is use as a check, if connections are possible. This allowes for a more fine grained control than the type registration.

Parameters

  [in,out] | obj | ConnectorImaging object
  [in] | func | the check function

Returns
  1 - error; 0 - success; -1 - otherwise

Version
  Oyranos: 0.3.0

Since
  2011/01/31 (Oyranos: 0.3.0)

Date
  2011/01/31

Examples:
  oyranos_cmm_oJPG.c.

## ◆ oyConnectorImaging_SetReg()

int oyConnectorImaging_SetReg | ( | oyConnectorImaging_s * | obj,
|  | const char * | type_registration
| ) |  |

Set this connectors type string.

Function oyConnectorImaging_SetReg

This is use as a rough check, if connections are possible.

Parameters

  [in,out] | obj | ConnectorImaging object
  [in] | type_registration | the registration string to describe the type

Returns
  1 - error; 0 - success; -1 - otherwise

Version
  Oyranos: 0.3.0

Since
  2011/01/31 (Oyranos: 0.3.0)

Date
  2011/01/31

Examples:
  oyranos_cmm_oJPG.c.

## ◆ oyConnectorImaging_SetTexts()

OYAPI int OYEXPORT oyConnectorImaging_SetTexts | ( | oyConnectorImaging_s * | obj,
|  | oyCMMGetText_f | getText,
|  | const char ** | text_classes
| ) |  |

set the texts in a connector

Function oyConnectorImaging_SetTexts

Set UI strings.

Parameters

  [in] | obj | ConnectorImaging object
  [in] | getText | the name function
  [in] | text_classes | zero terminated list of classes, e.g. {"name",NULL} owned by the user, but has to live the lifetime of the object

Returns
  status

Version
  Oyranos: 0.9.5

Date
  2013/06/10

Since
  2013/06/10 (Oyranos: 0.9.5)

Examples:
  oyranos_cmm_oJPG.c.

## Field Documentation

## ◆ copy

oyStruct_Copy_f oyConnectorImaging_s::copy

Copy function.

## ◆ oy_

oyObject_s oyConnectorImaging_s::oy_

Oyranos internal object.

Features name and hash. Do not change during object life time.

## ◆ release

oyStruct_Release_f oyConnectorImaging_s::release

Release function.

## ◆ type_

const oyOBJECT_e oyConnectorImaging_s::type_

Type of object.

The struct type tells Oyranos how to interprete hidden fields.